#ifndef __COMMANDS_H__
#define __COMMANDS_H__

#define VERSION_CMDH  0
#define VERSION_CMDL  1

struct dataexchange_t{
  uint8_t cmd:8;
  uint8_t data2:8;
  uint8_t data1:8;
  uint8_t data0:8;
};

#define CMD_NOP 0xFF
#define CMD_RAW_UART  1
//data0 = data ; data1,data2 - ignore
#define CMD_PWR       2
//data0[0] - pwr
#define CMD_ADC_FREQ  3
//data2 - channel_mask ; data1 - hign( freq(Hz) ) ; data0 - low( freq(Hz) )
#define CMD_AMPL      4
//data2 - channel mask ; data0 - ampl_code
#define CMD_CAL       5
//data2 - channel mask ; data0 - mode
#define CMD_SUBCHANNEL  6
//data2 - channel_mask ; data0 - subchannel
#define CMD_APPLY     7
//data2 - channel_mask
#define CMD_CH_ENABLE   8
//data1 - channels_on_mask ; data0 - channels_off_mask (mask_off > mask_on)
#define CMD_UART_SPEED  9
//data1:data0 - baudrate
#define CMD_REINIT      10
#define CMD_VER         11


#define REP_ERROR     0xFF
#define REP_VER       1
#define REP_PWR       2
//data0 = pwr

#define REP_3BIT_MASK  0xE0
#define REP_ADC       0x80
//0,1 bits - ADC num
//2,3,4 bits - scale
//5,6 = 0
#define REP_RAW_UART  0x20
//0,1 bits - num of bytes read (if =0 -> no data)
//data0 - 1st byte ; data1 - 2nd byte ; data3 - 3rd byte;

#endif
