#ifndef __PINMACRO_H__
#define __PINMACRO_H__
//ver. 1.3 at 18.01.17 - changed num()->BITx() ; bnum()->BITMx()
//ver. 1.2 at 28.11.16 - added PIN_ON / PIN_OFF
//ver. 1.1 at 24.11.16 - added PORT_ON / PORT_OFF, PORT_T
//ver. 1.0 <  23.09.16 - added all

#define _PM_ARG1(a,...)	a
#define _PM_ARG2(a,b,...)	b
#define _PM_ARG3(a,b,c,...) c
#define _PM_CONCAT(a,b)	a##b
#define _PM_PORT(a,b,...)	PORT##a
#define _PM_DDR(a,b,...)	DDR##a
#define _PM_PIN(a,b,...)	PIN##a
//              #define
#define arg1(x)			_PM_ARG1(x)
#define arg2(x)			_PM_ARG2(x)
#define arg3(x)         _PM_ARG3(x)
#define concat(x)		_PM_CONCAT(x)
#define PORTx(x)		_PM_PORT(x)
#define DDRx(x)			_PM_DDR(x)
#define PINx(x)			_PM_PIN(x)
#define BITx(x)			_PM_ARG2(x)
#define BITMx(x)		(1<<_PM_ARG2(x))
/*        
 * 
 *  :
 * (0) #define ANY_PORT B,1,args
 * (1) DDR_0(ANY_PORT);
 * (2) if(PIN_1(ANY_PORT))
 * (3)   PORT_1(ANY_PORT);
 * 
 * :
 * (0)      .      (args),   
 * (1)     .    DDRB1 = 0.
 * (2)    .1 (PIN_0   0 ).    if( PINB0 == 1 )
 * (3)    .1.    PORTB1 = 1
 */
#define PORT_0(x)	do{_PM_PORT(x) &=~(1<<_PM_ARG2(x));}while(0)
#define PORT_1(x)	do{_PM_PORT(x) |= (1<<_PM_ARG2(x));}while(0)
#define PORT_T(x)   do{_PM_PORT(x) ^= (1<<_PM_ARG2(x));}while(0)
#define DDR_0(x)	do{_PM_DDR(x) &=~(1<<_PM_ARG2(x));}while(0)
#define DDR_1(x)	do{_PM_DDR(x) |= (1<<_PM_ARG2(x));}while(0)
#define PIN_0(x)	(!(_PM_PIN(x) & (1<<_PM_ARG2(x))))
#define PNI_1(x)	(_PM_PIN(x) & (1<<_PM_ARG2(x)))
/*   ,    (3- ;  )
 * 
 *  :
 * (0) #define LED C,2,0
 * (1) #define BTN B,4,0
 * (2) if(PIN_ON(BTN))
 * (3)   PORT_ON(LED);
 * 
 * :
 * (0)   ,    " ".        
 * (1)   ,    " ".            
 * (2)  "  ".    if( PINB4 == 0 )
 * (3)    "" .    PORTC2 = 0
 */
#define PORT_OFF(x) do{\
    _PM_PORT(x) = (_PM_PORT(x) &~ (_PM_ARG3(x)<<_PM_ARG2(x)) ) | ((!_PM_ARG3(x))<<_PM_ARG2(x));\
  }while(0)
#define PORT_ON(x) do{\
    _PM_PORT(x) = (_PM_PORT(x) &~ ((!_PM_ARG3(x))<<_PM_ARG2(x)) ) | (_PM_ARG3(x)<<_PM_ARG2(x));\
  }while(0)
#define PIN_OFF(x)   ( (( _PM_PIN(x)>>_PM_ARG2(x)) & 0x01) ^ _PM_ARG3(x))
#define PIN_ON(x)  ( ((~_PM_PIN(x)>>_PM_ARG2(x)) & 0x01) ^ _PM_ARG3(x))

#define NOINLINE __attribute__((__noinline__))

#endif
